#                        Copyright (c) 1987 Bellcore
#                            All Rights Reserved
#       Permission is granted to copy or use this program, EXCEPT that it
#       may not be sold for profit, the copyright notice must be reproduced
#       on copies, and credit should be given to Bellcore where it is due.
#       BELLCORE MAKES NO WARRANTY AND ACCEPTS NO LIABILITY FOR THIS PROGRAM.

----------------------------------------------------------------------------

Here is the atari version of MGR, a network transparent window system
originally written for Unix. This zoo file contains only the binaries,
some docs, and context diffs to the Sparc version of MGR (the file
sparcmgr.tar.Z on flash.bellcore.com). I've also included a limited number
of fonts and icons; more are included with the sparc distribution (q.v.).

MGR requires 1 megabyte of memory (more is better!) and the MiNT multitasking
system version 0.6 or better. MiNT was posted to comp.binaries.atari.st,
so check your local archive site if you need a copy. It runs in high or
medium resolution, and should work OK on a moniterm or similar large screen
monitor (all the screen graphics use the line A vector).

Some points specific to the Atari version:

(1) The ST's mouse has only 2 buttons; to simulate a "middle" mouse button,
press a shift key and either of the mouse buttons (I did it this way to make
things easier for left handers). Bad news: this can be somewhat clumsy,
since a lot of programs use the middle button and not many use the left.
Good news: MGR lets you re-map the mouse buttons any way you like. I like
having the system ("left") button on the right button, the "middle" button
on the left, and the "right" button (which isn't used much) on the shift+button
combination; the sample mgr.rc file shows how you can do this.

(2) "Buckey" keys are emulated with the Alternate key, e.g. "Buckey-m" (for
"move text") is ALT-m on the Atari. MGR passes any unrecognized buckey keys
through to applications as (0x80|key), so this provides an easy way for
your programs to read alternate keys.

(3) For programs that understand TERMCAP, set the TERM environment variable to
"mgr"; a sample termcap entry for an 80x24 window is provided in misc/termcap,
or you can set TERMCAP according to the output of set_term.prg.

(4) Programs with TOS vt52 escape sequences hard-wired in can be run in
a VT52 emulation window; use the provided "vt52.prg" to do this. The calling
sequence is:
   vt52 [program]: run "program" in an 80x25 vt52 window; default is $SHELL
   vt52 -f aux:  : read input from the rs232 port (you'll have to have set
                   the baud rate, etc. already; also, you may lose characters
                   even at 2400 baud).

Unless you've got a big screen, you'll probably want to set the font to
something small first with font.prg (e.g. font 1 or font 2).

(5) Most MGR client programs want forward slashes ("/") in pathnames instead
of the more usual (under TOS) backslash ("\").

(6) The startup file is called "mgr.rc" instead of ".mgrc".

(6) Environment variables (use forward slashes in these, too):
DEFAULT_FONT: path to the default font (e.g. "f:/mgr/font/sail6x8r.fnt")
MGRFONT: path to the "font" directory (default is "/mgr/font")
MGRICON: path to the "icon" directory (default is "/mgr/icon")
HOME: place to look for "mgr.rc" startup file (no default)
SHELL: shell to run in windows (default "init.prg")
The first three of these can also be set on the command line.


Contents:
readme.st:	this file
readme:		original MGR readme
mgr.rc:		a sample startup file
bin:		some executable programs (mgr.prg is the most important
		one, obviously :-). vt52.prg is a VT52 terminal emulator
		that may be used to run TOS programs that don't understand
		TERMCAP (most of them, unfortunately)
doc:		some doc files; usrman.out is the nroff-compiled user guide for
		MGR; the others are nroff manual pages.
font:		some sample fonts
icon:		some sample icons; view with browse.prg.
lib:		the MGR library, in source and gcc archive format. Note that
		the version of libmgr.a provided does *not* include scribe.o;
		I was unable to compile scribe.c (I ran out of memory on my
		4 megabyte ST; probably cross-compiling on a Sun would be the
		only solution, or using a different compiler)
misc:		some miscellaneous files (not all of the ones mentioned in
		the README are included). Try "cat map" and "cat tree.out".
src/atari:	atari bitblit library
atari:		the diffs to the mgr source code
contrib/atari:	the source code for vt52.prg
